//SPDX-License-Identifier: Unlicense
    pragma solidity ^0.8.19; // tells the solidity version to the complier
    
    // get the OpenZeppelin Contracts, we will use to creat our own
    import "./ERC721URIStorage.sol";
    import "./Counters.sol";
    
    contract Teeest123 is ERC721URIStorage {
    
    // keep count of the tokenId
    using Counters for Counters.Counter; // keep track of the token id's
    Counters.Counter private _tokenIds;
    
    uint256 public constant maxSupply = 2; // set the max supply of NFT's for your collection
    string public nftUri;
    constructor() ERC721 ("test", "RB") { // construct your token, needs name and symbol
    }
    
    function createNFT(string memory tokenUri) public { //function to create nfts
      nftUri = tokenUri;
      uint256 newItemId = _tokenIds.current(); // get the tokenId
    
      require(newItemId < maxSupply); // check if the total supply has been reached 
    
      _safeMint(msg.sender, newItemId); // mint the nft from the sender account 
    
      _setTokenURI(newItemId, nftUri); // add the contents to the nft 
      // the content of this nft is on the url above. This means that the nft is an off-chain nft
      // if the server with the content changes then the image in the url changes 
    
      _tokenIds.increment(); // increment the token, so when the next person calls the function it will be the next token in line 
     }
    }