"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = void 0;
var express_1 = __importDefault(require("express"));
var dotenv_1 = __importDefault(require("dotenv"));
var body_parser_1 = __importDefault(require("body-parser"));
var swagger_ui_express_1 = __importDefault(require("swagger-ui-express"));
var esdt_1 = require("./routesOperations/esdt");
var errorHandler_1 = require("./errorHandler");
var issueEsdtValidator_1 = require("./validators/esdtValidators/issueEsdtValidator");
var transferEsdtValidator_1 = require("./validators/esdtValidators/transferEsdtValidator");
var setRoleValidator_1 = require("./validators/esdtValidators/setRoleValidator");
var localMintValidator_1 = require("./validators/esdtValidators/localMintValidator");
var localBurnValidator_1 = require("./validators/esdtValidators/localBurnValidator");
var pauseUnPauseValidator_1 = require("./validators/esdtValidators/pauseUnPauseValidator");
var freezeValidator_1 = require("./validators/esdtValidators/freezeValidator");
var unFreezeValidator_1 = require("./validators/esdtValidators/unFreezeValidator");
var wipeValidator_1 = require("./validators/esdtValidators/wipeValidator");
var controlChangesValidator_1 = require("./validators/esdtValidators/controlChangesValidator");
var transferOwnershipValidator_1 = require("./validators/esdtValidators/transferOwnershipValidator");
var swaggerDocument = __importStar(require("../blockchain-helpers.swagger.json"));
var nftCreateValidator_1 = require("./validators/nftValidator/nftCreateValidator");
var nft_1 = require("./routesOperations/nft");
var nftTransferValidator_1 = require("./validators/nftValidator/nftTransferValidator");
var nftIssueValidator_1 = require("./validators/nftValidator/nftIssueValidator");
var nftSetRoleValidator_1 = require("./validators/nftValidator/nftSetRoleValidator");
var nftStopCreateValidator_1 = require("./validators/nftValidator/nftStopCreateValidator");
var nftTransferNftCreateRole_1 = require("./validators/nftValidator/nftTransferNftCreateRole");
var nftUpdateAttributesValidator_1 = require("./validators/nftValidator/nftUpdateAttributesValidator");
var nftAddUriValidator_1 = require("./validators/nftValidator/nftAddUriValidator");
var nftFreezeSingleNftValidator_1 = require("./validators/nftValidator/nftFreezeSingleNftValidator");
var nftWipeSingleNftValidator_1 = require("./validators/nftValidator/nftWipeSingleNftValidator");
var serverless_http_1 = __importDefault(require("serverless-http"));
// import { rateLimiterMiddleware } from "./rateLimiterMiddleware";
var ethToken_1 = require("./routesOperations/ethToken");
var nftUnfreezeSingleNftValidator_1 = require("./validators/nftValidator/nftUnfreezeSingleNftValidator");
var sft_1 = require("./routesOperations/sft");
var metaEsdt_1 = require("./routesOperations/metaEsdt");
var sftIssueValidator_1 = require("./validators/sftValidators/sftIssueValidator");
var setSpecialRoleValidator_1 = require("./validators/sftValidators/setSpecialRoleValidator");
var esdtNftAddQuantityValidator_1 = require("./validators/sftValidators/esdtNftAddQuantityValidator");
var sftCreateValidator_1 = require("./validators/sftValidators/sftCreateValidator");
var esdtNftBurnValidator_1 = require("./validators/sftValidators/esdtNftBurnValidator");
var registerMetaESDTValidator_1 = require("./validators/metaEsdtValidators/registerMetaESDTValidator");
var changeSFTToMetaESDTValidator_1 = require("./validators/metaEsdtValidators/changeSFTToMetaESDTValidator");
var bscToken_1 = require("./routesOperations/bscToken");
var maticToken_1 = require("./routesOperations/maticToken");
dotenv_1.default.config();
var app = (0, express_1.default)();
app.use(function (req, res, next) {
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
    next();
});
// app.use(directorySetup);
app.use("/api-docs", swagger_ui_express_1.default.serve, swagger_ui_express_1.default.setup(swaggerDocument, {
    swaggerOptions: { displayRequestDuration: true },
}));
// app.use(rateLimiterMiddleware);
app.use(body_parser_1.default.urlencoded({ extended: false }));
app.use(body_parser_1.default.json());
app.post("/esdt/issue", issueEsdtValidator_1.issueEsdtValidator, esdt_1.issueESDT, errorHandler_1.errorHandler);
app.post("/esdt/transfer", transferEsdtValidator_1.transferEsdtValidator, esdt_1.transferESDT, errorHandler_1.errorHandler);
app.post("/esdt/setRole", setRoleValidator_1.setRoleEsdtValidator, esdt_1.setSpecialRoleESDT, errorHandler_1.errorHandler);
app.post("/esdt/unSetRole", setRoleValidator_1.setRoleEsdtValidator, esdt_1.unSetSpecialRoleESDT, errorHandler_1.errorHandler);
app.post("/esdt/localMint", localMintValidator_1.localMintValidator, esdt_1.localMint, errorHandler_1.errorHandler);
app.post("/esdt/localBurn", localBurnValidator_1.localBurnValidator, esdt_1.localBurn, errorHandler_1.errorHandler);
app.post("/esdt/pause", pauseUnPauseValidator_1.pauseValidator, esdt_1.pause, errorHandler_1.errorHandler);
app.post("/esdt/unPause", pauseUnPauseValidator_1.pauseValidator, esdt_1.unPause, errorHandler_1.errorHandler);
app.post("/esdt/freeze", freezeValidator_1.freezeValidator, esdt_1.freeze, errorHandler_1.errorHandler);
app.post("/esdt/unFreeze", unFreezeValidator_1.unFreezeValidator, esdt_1.unFreeze, errorHandler_1.errorHandler);
app.post("/esdt/wipe", wipeValidator_1.wipeValidator, esdt_1.wipe, errorHandler_1.errorHandler);
app.post("/esdt/controlChanges", controlChangesValidator_1.controlChangesValidator, esdt_1.controlChanges, errorHandler_1.errorHandler);
app.post("/esdt/transferOwnership", transferOwnershipValidator_1.transferOwnershipValidator, esdt_1.transferOwnership, errorHandler_1.errorHandler);
app.post("/nft/create", nftCreateValidator_1.nftCreateValidator, nft_1.createNFT, errorHandler_1.errorHandler);
app.post("/nft/transfer", nftTransferValidator_1.nftTransferValidator, nft_1.transferNFT, errorHandler_1.errorHandler);
app.post("/nft/issue", nftIssueValidator_1.nftIssueValidator, nft_1.issueNFT, errorHandler_1.errorHandler);
app.post("/nft/setSpecialRole", nftSetRoleValidator_1.nftSetRoleValidator, nft_1.setSpecialRoleNFT, errorHandler_1.errorHandler);
app.post("/nft/stopNftCreate", nftStopCreateValidator_1.nftStopCreateValidator, nft_1.stopNftCreate, errorHandler_1.errorHandler);
app.post("/nft/transferNFTCreateRole", nftTransferNftCreateRole_1.nftTransferNFTCreateRole, nft_1.transferCreateRoleNFT, errorHandler_1.errorHandler);
app.post("/nft/updateAttributes", nftUpdateAttributesValidator_1.nftUpdateAttributesValidator, nft_1.updateAttributes, errorHandler_1.errorHandler);
app.post("/nft/addUri", nftAddUriValidator_1.nftAddURIValidator, nft_1.addUri, errorHandler_1.errorHandler);
app.post("/nft/freezeSingleNft", nftFreezeSingleNftValidator_1.nftFreezeSingleNftValidator, nft_1.freezeSingleNFT, errorHandler_1.errorHandler);
app.post("/nft/unFreezeSingleNft", nftUnfreezeSingleNftValidator_1.nftUnfreezeSingleNftValidator, nft_1.unFreezeSingleNFT, errorHandler_1.errorHandler);
app.post("/nft/wipeSingleNft", // authenticateToken
nftWipeSingleNftValidator_1.nftWipeSingleNFTValidator, nft_1.wipeSingleNFT, errorHandler_1.errorHandler);
app.post("/sft/sftIssue", sftIssueValidator_1.sftIssueValidator, sft_1.issueSft, errorHandler_1.errorHandler);
app.post("/sft/setSpecialRole", setSpecialRoleValidator_1.setSpecialRoleValidator, sft_1.setSpecialRole, errorHandler_1.errorHandler);
app.post("/sft/esdtNftAddQuantity", esdtNftAddQuantityValidator_1.esdtNftAddQuantityValidator, sft_1.esdtNftAddQuantity, errorHandler_1.errorHandler);
app.post("/sft/esdtNftBurn", esdtNftBurnValidator_1.esdtNftBurnValidator, sft_1.esdtNftBurn, errorHandler_1.errorHandler);
app.post("/sft/esdtNftCreate", sftCreateValidator_1.sftCreateValidator, sft_1.esdtNftCreate, errorHandler_1.errorHandler);
app.post("/metaEsdt/registerMetaESDT", registerMetaESDTValidator_1.registerMetaESDTValidator, metaEsdt_1.registerMetaESDT, errorHandler_1.errorHandler);
app.post("/metaEsdt/changeSFTToMetaESDT", changeSFTToMetaESDTValidator_1.changeSFTToMetaESDTValidator, metaEsdt_1.changeSftToMetaEsdt, errorHandler_1.errorHandler);
app.post("/eth/token/transfer", ethToken_1.transferEthToken, errorHandler_1.errorHandler); // to add verify for token and nft contract
app.post("/eth/token/create", ethToken_1.createEthToken, errorHandler_1.errorHandler);
app.post("/eth/nft/createCollection", ethToken_1.nftCreateCollection, errorHandler_1.errorHandler);
app.post("/eth/nft/mintNft", ethToken_1.mintNftEth, errorHandler_1.errorHandler);
app.post("/eth/nft/smartContract/verify", ethToken_1.verifyEthNft, errorHandler_1.errorHandler);
app.post("/eth/token/smartContract/verify", ethToken_1.verifyEthToken, errorHandler_1.errorHandler);
app.post("/eth/smartContract/getAbiFunctions", ethToken_1.getAbiFunctions, errorHandler_1.errorHandler);
app.post("/eth/smartContract/getAbi", ethToken_1.getAbiEth, errorHandler_1.errorHandler);
app.post("/bsc/token/transfer", bscToken_1.transferBscToken, errorHandler_1.errorHandler);
app.post("/bsc/token/create", bscToken_1.createBscToken, errorHandler_1.errorHandler);
app.post("/bsc/nft/createCollection", bscToken_1.createBscNftCollection, errorHandler_1.errorHandler);
app.post("/bsc/nft/mintNft", bscToken_1.mintBscNft, errorHandler_1.errorHandler); // to add verify
app.post("/bsc/smartContract/getAbiFunctions", bscToken_1.getAbiFunctionsBsc, errorHandler_1.errorHandler);
app.post("/bsc/smartContract/getAbi", bscToken_1.getAbiBsc, errorHandler_1.errorHandler);
app.post("/bsc/token/smartContract/verify", bscToken_1.verifyBscToken, errorHandler_1.errorHandler);
app.post("/bsc/nft/smartContract/verify", bscToken_1.verifyBscNft, errorHandler_1.errorHandler);
app.post("/matic/token/transfer", maticToken_1.transferMaticToken, errorHandler_1.errorHandler);
app.post("/matic/token/create", maticToken_1.createMaticToken, errorHandler_1.errorHandler);
app.post("/matic/token/verify", maticToken_1.maticTokenVerify, errorHandler_1.errorHandler);
app.post("/matic/nft/create", maticToken_1.createMaticNftCollection, errorHandler_1.errorHandler);
app.post("/matic/nft/mint", maticToken_1.maticMintToken, errorHandler_1.errorHandler);
app.post("/matic/nft/verify", maticToken_1.maticNftVerify, errorHandler_1.errorHandler);
app.post("/matic/smartContract/getAbi", maticToken_1.getAbiMatic, errorHandler_1.errorHandler);
app.post("/matic/smartContract/getAbiFunctions", maticToken_1.getAbiFunctionsMatic, errorHandler_1.errorHandler);
app.listen(3001, function () {
    return console.log("Express is listening at http://localhost:".concat(3001));
});
exports.handler = (0, serverless_http_1.default)(app);
//# sourceMappingURL=index.js.map