"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rateLimiterMiddleware = void 0;
var rate_limiter_flexible_1 = require("rate-limiter-flexible");
// Limits number of requests to 10 per 15 minutes
var MAX_REQUEST_LIMIT = 10;
var MAX_REQUEST_WINDOW = 15 * 60; // Per 15 minutes by IP
var TOO_MANY_REQUESTS_MESSAGE = "Too many requests";
var options = {
    duration: MAX_REQUEST_WINDOW,
    points: MAX_REQUEST_LIMIT,
};
var rateLimiter = new rate_limiter_flexible_1.RateLimiterMemory(options);
var rateLimiterMiddleware = function (req, res, next) {
    rateLimiter
        .consume(req.ip)
        .then(function () {
        next();
    })
        .catch(function () {
        res.status(429).json({ message: TOO_MANY_REQUESTS_MESSAGE });
    });
};
exports.rateLimiterMiddleware = rateLimiterMiddleware;
//# sourceMappingURL=rateLimiterMiddleware.js.map