"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transferOwnership = exports.controlChanges = exports.wipe = exports.unFreeze = exports.freeze = exports.unPause = exports.pause = exports.localBurn = exports.localMint = exports.unSetSpecialRoleESDT = exports.setSpecialRoleESDT = exports.transferESDT = exports.issueESDT = void 0;
var transactionBuilder_1 = require("../transactionBuilder");
var issueESDT = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildIssue)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.issueESDT = issueESDT;
var transferESDT = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildTransfer)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.transferESDT = transferESDT;
var setSpecialRoleESDT = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildSetRole)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.setSpecialRoleESDT = setSpecialRoleESDT;
var unSetSpecialRoleESDT = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildUnSetRole)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.unSetSpecialRoleESDT = unSetSpecialRoleESDT;
var localMint = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildLocalMint)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.localMint = localMint;
var localBurn = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildLocalBurn)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.localBurn = localBurn;
var pause = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildPause)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.pause = pause;
var unPause = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildUnPause)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.unPause = unPause;
var freeze = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildFreeze)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.freeze = freeze;
var unFreeze = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildUnFreeze)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.unFreeze = unFreeze;
var wipe = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildWipe)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.wipe = wipe;
var controlChanges = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildControlChanges)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.controlChanges = controlChanges;
var transferOwnership = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var address, networkProvider, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                address = req.body.address;
                networkProvider = req.body.networkProvider;
                return [4 /*yield*/, (0, transactionBuilder_1.buildTransferOwnership)(req.body, address, networkProvider)];
            case 1:
                tx = _a.sent();
                res.send(tx);
                return [2 /*return*/];
        }
    });
}); };
exports.transferOwnership = transferOwnership;
//# sourceMappingURL=esdt.js.map