"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildTransferOwnership = exports.buildControlChanges = exports.buildWipe = exports.buildUnFreeze = exports.buildFreeze = exports.buildUnPause = exports.buildPause = exports.buildLocalBurn = exports.buildLocalMint = exports.buildUnSetRole = exports.buildSetRole = exports.buildTransfer = exports.buildIssue = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var buildIssue = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.issue,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                console.log("Transaction built: ".concat(JSON.stringify(tx)));
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildIssue = buildIssue;
var buildTransfer = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.transfer,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                console.log("Transaction built: ".concat(JSON.stringify(tx)));
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildTransfer = buildTransfer;
var buildSetRole = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.setSpecialRole,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                console.log("Transaction built: ".concat(JSON.stringify(tx)));
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildSetRole = buildSetRole;
var buildUnSetRole = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.unSetSpecialRole,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                console.log("Transaction built: ".concat(JSON.stringify(tx)));
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildUnSetRole = buildUnSetRole;
var buildLocalMint = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.localMint,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                console.log("Transaction built: ".concat(JSON.stringify(tx)));
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildLocalMint = buildLocalMint;
var buildLocalBurn = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.localBurn,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                console.log("Transaction built: ".concat(JSON.stringify(tx)));
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildLocalBurn = buildLocalBurn;
var buildPause = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.pause,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildPause = buildPause;
var buildUnPause = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.unPause,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildUnPause = buildUnPause;
var buildFreeze = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.freeze,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildFreeze = buildFreeze;
var buildUnFreeze = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.unFreeze,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildUnFreeze = buildUnFreeze;
var buildWipe = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.wipe,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildWipe = buildWipe;
var buildControlChanges = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.controlChanges,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildControlChanges = buildControlChanges;
var buildTransferOwnership = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var elrondInstance, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                elrondInstance = new zoidpay_blockchain_helpers_1.Elrond.Client({
                    address: address,
                    networkProvider: networkProvider,
                });
                return [4 /*yield*/, elrondInstance.buildTransaction({
                        transactionCategory: zoidpay_blockchain_helpers_1.Elrond.models.TransactionCategory.ESDT,
                        transactionType: zoidpay_blockchain_helpers_1.Elrond.models.ESDTFunctions.transferOwnership,
                        operationsData: body,
                    })];
            case 1:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildTransferOwnership = buildTransferOwnership;
//# sourceMappingURL=transactionBuilder.js.map