"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildGetAbiMatic = exports.buildMaticNftVerify = exports.buildMaticMintToken = exports.buildCreateNftMaticCollection = exports.buildMaticTokenVerify = exports.buildCreateMaticToken = exports.buildTransferMaticToken = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var buildTransferMaticToken = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var bsc, web3, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                bsc = new zoidpay_blockchain_helpers_1.Polygon.Client({
                    networkProvider: networkProvider,
                    address: address,
                });
                return [4 /*yield*/, bsc.establishConnection()];
            case 1:
                web3 = _a.sent();
                return [4 /*yield*/, bsc.buildTransation(zoidpay_blockchain_helpers_1.Polygon.models.MaticTransactionCategory.ERC20, "transferToken", body, web3)];
            case 2:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildTransferMaticToken = buildTransferMaticToken;
var buildCreateMaticToken = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var bsc, web3, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                bsc = new zoidpay_blockchain_helpers_1.Polygon.Client({
                    networkProvider: networkProvider,
                    address: address,
                });
                return [4 /*yield*/, bsc.establishConnection()];
            case 1:
                web3 = _a.sent();
                return [4 /*yield*/, bsc.buildTransation(zoidpay_blockchain_helpers_1.Polygon.models.MaticTransactionCategory.ERC20, "createToken", body, web3)];
            case 2:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildCreateMaticToken = buildCreateMaticToken;
var buildMaticTokenVerify = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var polygon, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                polygon = new zoidpay_blockchain_helpers_1.Polygon.Client({
                    networkProvider: networkProvider,
                    address: address,
                });
                return [4 /*yield*/, polygon.verifyTokenContract(body)];
            case 1:
                _a.sent();
                return [2 /*return*/, "Your token was verified"];
            case 2:
                err_1 = _a.sent();
                return [2 /*return*/, "Your token could not be verified. Please check if your contract was deployed with our services or if the input you provided is correct."];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.buildMaticTokenVerify = buildMaticTokenVerify;
var buildCreateNftMaticCollection = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var bsc, web3, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                bsc = new zoidpay_blockchain_helpers_1.Polygon.Client({
                    networkProvider: networkProvider,
                    address: address,
                });
                return [4 /*yield*/, bsc.establishConnection()];
            case 1:
                web3 = _a.sent();
                return [4 /*yield*/, bsc.buildTransation(zoidpay_blockchain_helpers_1.Polygon.models.MaticTransactionCategory.ERC721, "createNftCollection", body, web3)];
            case 2:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildCreateNftMaticCollection = buildCreateNftMaticCollection;
var buildMaticMintToken = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var bsc, web3, tx;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                bsc = new zoidpay_blockchain_helpers_1.Polygon.Client({
                    networkProvider: networkProvider,
                    address: address,
                });
                return [4 /*yield*/, bsc.establishConnection()];
            case 1:
                web3 = _a.sent();
                return [4 /*yield*/, bsc.buildTransation(zoidpay_blockchain_helpers_1.Polygon.models.MaticTransactionCategory.ERC721, "mintNft", body, web3)];
            case 2:
                tx = _a.sent();
                return [2 /*return*/, tx];
        }
    });
}); };
exports.buildMaticMintToken = buildMaticMintToken;
var buildMaticNftVerify = function (body, address, networkProvider) { return __awaiter(void 0, void 0, void 0, function () {
    var polygon, err_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                polygon = new zoidpay_blockchain_helpers_1.Polygon.Client({
                    networkProvider: networkProvider,
                    address: address,
                });
                return [4 /*yield*/, polygon.verifyNftContract(body)];
            case 1:
                _a.sent();
                return [2 /*return*/, "Your token was verified"];
            case 2:
                err_2 = _a.sent();
                return [2 /*return*/, "Your token could not be verified. Please check if your contract was deployed with our services or if the input you provided is correct."];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.buildMaticNftVerify = buildMaticNftVerify;
var buildGetAbiMatic = function (address, networkProvider, smartContractAddress) { return __awaiter(void 0, void 0, void 0, function () {
    var polygon, tx, err_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                polygon = new zoidpay_blockchain_helpers_1.Polygon.Client({
                    networkProvider: networkProvider,
                    address: address,
                });
                return [4 /*yield*/, polygon.getContractAbi(smartContractAddress)];
            case 1:
                tx = _a.sent();
                return [2 /*return*/, tx];
            case 2:
                err_3 = _a.sent();
                return [2 /*return*/, "Could not retrieve ABI"];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.buildGetAbiMatic = buildGetAbiMatic;
//# sourceMappingURL=transactionBuilderMatic.js.map