"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.issueEsdtValidator = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var issueEsdtValidator = function (req, res, next) {
    var payload = req.body;
    if (!payload.address)
        throw new Error("The `address` parameter is not present.");
    if (!payload.tokenTicker)
        throw new Error("The `tokenTicker` parameter is not present.");
    if (!payload.tokenName)
        throw new Error("The `tokenName` parameter is not present.");
    if (!payload.initialSupply)
        throw new Error("The `initialSupply` parameter is not present.");
    if (!payload.numberOfDecimals)
        throw new Error("The `numberOfDecimals` parameter is not present.");
    if (!payload.networkProvider)
        throw new Error("The 'networkProvider' parameter is not present. Please provide one of the following network providers: '".concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.devnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.mainnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.testnet, "'"));
    next();
};
exports.issueEsdtValidator = issueEsdtValidator;
//# sourceMappingURL=issueEsdtValidator.js.map