"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transferEsdtValidator = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var transferEsdtValidator = function (req, res, next) {
    var payload = req.body;
    if (!payload.tokenTicker)
        throw new Error("The `tokenTicker` parameter is not present.");
    if (!payload.valueToTransfer)
        throw new Error("The `valueToTransfer` parameter is not present.");
    if (!payload.addressToSendTo)
        throw new Error("The `addressToSendTo` parameter is not present.");
    if (!payload.networkProvider)
        throw new Error("The 'networkProvider' parameter is not present. Please provide one of the following network providers: '".concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.devnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.mainnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.testnet, "'"));
    next();
};
exports.transferEsdtValidator = transferEsdtValidator;
//# sourceMappingURL=transferEsdtValidator.js.map