"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unFreezeValidator = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var unFreezeValidator = function (req, res, next) {
    var payload = req.body;
    if (!payload.address)
        throw new Error("The `address` parameter is not present.");
    if (!payload.tokenTicker)
        throw new Error("The `tokenTicker` parameter is not present.");
    if (!payload.addressToUnfreeze)
        throw new Error("The `addressToUnfreeze` parameter is not present.");
    if (!payload.networkProvider)
        throw new Error("The 'networkProvider' parameter is not present. Please provide one of the following network providers: '".concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.devnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.mainnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.testnet, "'"));
    next();
};
exports.unFreezeValidator = unFreezeValidator;
//# sourceMappingURL=unFreezeValidator.js.map