"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nftCreateValidator = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var nftCreateValidator = function (req, res, next) {
    var payload = req.body;
    if (!payload.address)
        throw new Error("The `address` parameter is not present.");
    if (!payload.tokenIdentifier)
        throw new Error("The `tokenIdentifier` parameter is not present.");
    if (!payload.nftName)
        throw new Error("The `nftName` parameter is not present.");
    if (!payload.royalties)
        throw new Error("The `royalties` parameter is not present.");
    if (!payload.addressToSendTo)
        throw new Error("The `addressToSendTo` parameter is not present.");
    if (!payload.URILinks)
        throw new Error("The `URILinks` parameter is not present.");
    if (!payload.senderAddress)
        throw new Error("The `senderAddress` parameter is not present.");
    if (!payload.hash)
        throw new Error("The `URILinks` hash is not present.");
    if (!payload.hash)
        throw new Error("The `attributes` hash is not present.");
    if (!payload.nftName)
        throw new Error("The `nftName` parameter is not present.");
    if (!payload.networkProvider)
        throw new Error("The 'networkProvider' parameter is not present. Please provide one of the following network providers: '".concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.devnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.mainnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.testnet, "'"));
    next();
};
exports.nftCreateValidator = nftCreateValidator;
//# sourceMappingURL=nftCreateValidator.js.map