"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nftTransferNFTCreateRole = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var nftTransferNFTCreateRole = function (req, res, next) {
    var payload = req.body;
    if (!payload.address)
        throw new Error("The `address` parameter is not present.");
    if (!payload.tokenIdentifier)
        throw new Error("The `tokenIdentifier` parameter is not present.");
    if (!payload.addressToTransferFrom)
        throw new Error("The `addressToTransferFrom` parameter is not present or is not a number.");
    if (!payload.addressToTransferTo)
        throw new Error("The `addressToTransferTo` parameter is not present or is not a number.");
    if (!payload.networkProvider)
        throw new Error("The 'networkProvider' parameter is not present. Please provide one of the following network providers: '".concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.devnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.mainnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.testnet, "'"));
    next();
};
exports.nftTransferNFTCreateRole = nftTransferNFTCreateRole;
//# sourceMappingURL=nftTransferNftCreateRole.js.map