"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nftTransferValidator = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var nftTransferValidator = function (req, res, next) {
    var payload = req.body;
    if (!payload.address)
        throw new Error("The `address` parameter is not present.");
    if (!payload.collectionIdenfier)
        throw new Error("The `collectionIdenfier` parameter is not present.");
    if (!payload.nftNonce && !isNaN(payload.nftNonce))
        throw new Error("The `nftNonce` parameter is not present or is not a number.");
    if (!payload.quantityToTransfer && !isNaN(payload.quantityToTransfer))
        throw new Error("The `quantityToTransfer` parameter is not present or is not a number");
    if (!payload.destinationAddress)
        throw new Error("The `destinationAddress` parameter is not present.");
    if (!payload.networkProvider)
        throw new Error("The 'networkProvider' parameter is not present. Please provide one of the following network providers: '".concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.devnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.mainnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.testnet, "'"));
    next();
};
exports.nftTransferValidator = nftTransferValidator;
//# sourceMappingURL=nftTransferValidator.js.map