"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.esdtNftAddQuantityValidator = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var esdtNftAddQuantityValidator = function (req, res, next) {
    var payload = req.body;
    if (!payload.address)
        throw new Error("The `address` parameter is not present.");
    if (!payload.tokenIdentifier)
        throw new Error("The `tokenIdentifier` parameter is not present.");
    if (!payload.nftNonce)
        throw new Error("The `nftNonce` parameter is not present.");
    if (!payload.quantityToAdd)
        throw new Error("The `quantityToAdd` parameter is not present.");
    if (!payload.senderAddress)
        throw new Error("The `quantityToAdd` parameter is not present.");
    if (!payload.networkProvider)
        throw new Error("The 'networkProvider' parameter is not present. Please provide one of the following network providers: '".concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.devnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.mainnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.testnet, "'"));
    next();
};
exports.esdtNftAddQuantityValidator = esdtNftAddQuantityValidator;
//# sourceMappingURL=esdtNftAddQuantityValidator.js.map