"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sftCreateValidator = void 0;
var zoidpay_blockchain_helpers_1 = require("@zoidpay-tech/zoidpay-blockchain-helpers");
var sftCreateValidator = function (req, res, next) {
    var payload = req.body;
    if (!payload.address)
        throw new Error("The `address` parameter is not present.");
    if (!payload.tokenIdentifier)
        throw new Error("The `tokenIdentifier` parameter is not present.");
    if (!payload.nftNonce)
        throw new Error("The `nftNonce` parameter is not present.");
    if (!payload.initialQuantity)
        throw new Error("The `initialQuantity` parameter is not present or is not a number.");
    if (!payload.nftName)
        throw new Error("The `nftName` parameter is not present or is not a number.");
    if (!payload.royalties)
        throw new Error("The `royalties` parameter is not present or is not a number.");
    if (!payload.addressToSendTo)
        throw new Error("The `addressToSendTo` parameter is not present.");
    if (!payload.URILinks)
        throw new Error("The `URILinks` parameter is not present.");
    if (!payload.senderAddress)
        throw new Error("The `senderAddress` parameter is not present.");
    if (!payload.hash)
        throw new Error("The `hash` parameter is not present.");
    if (!payload.attributes)
        throw new Error("The `attributes` parameter is not present.");
    if (!payload.networkProvider)
        throw new Error("The 'networkProvider' parameter is not present. Please provide one of the following network providers: '".concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.devnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.mainnet, "', '").concat(zoidpay_blockchain_helpers_1.Elrond.models.NetworkProvider.testnet, "'"));
    next();
};
exports.sftCreateValidator = sftCreateValidator;
//# sourceMappingURL=sftCreateValidator.js.map