/** @type import('hardhat/config').HardhatUserConfig */
require("@nomiclabs/hardhat-etherscan");
require("@nomicfoundation/hardhat-toolbox");
const env = process.env;
const sources = env.HARDHAT_SOURCES_PATH;
const cache = env.HARDHAT_CACHE_PATH;
const artifacts = env.HARDHAT_ARTIFACTS_PATH;
const rootPath = env.ROOT_PATH_HARDHAT;

// SEPOLIA CONFIG
let ethConfig = {
  defaultNetwork: "sepolia",
  solidity: "0.8.19",
  etherscan: {
    apiKey: "YBXXIN9TBE28XZNZNS2PQ1A7XRJHYF94GU",
  },
  paths: {
    // root: rootPath,
    sources: sources,
    cache: cache,
    artifacts: artifacts,
  },
  networks: {
    sepolia: {
      url: "https://rpc.sepolia.org",
      accounts: [ // private key
        "eb6f20f9d5ae826e90b347668529cb042c6b1dd1a89990ceeea36c8fba23ccc4",
      ],
    },
    mainnet: {
      url: ETH_MAINNET_RPC_URL, // mainnet rpc url
      accounts: ["eb6f20f9d5ae826e90b347668529cb042c6b1dd1a89990ceeea36c8fba23ccc4"] // mainnet wallet addres private key
  },
  },
};

let bscConfig = {
  defaultNetwork: "testnet",
  etherscan: {
    apiKey: {
      bscTestnet: "F249VW1ZCUH9UK8VY2YPM3VPIQZQJERWZQ",
    },
  },
  networks: {
    testnet: {
      url: "https://data-seed-prebsc-1-s1.binance.org:8545",
      // chainId: 97,
      // gasPrice: 20000000000,
      accounts: [
        "eb6f20f9d5ae826e90b347668529cb042c6b1dd1a89990ceeea36c8fba23ccc4",
      ],
    },
      mainnet: {
        url: "https://bsc-dataseed.binance.org/", // mainnet rpc url
        chainId: 56,
        gasPrice: 20000000000,
        accounts: ['eb6f20f9d5ae826e90b347668529cb042c6b1dd1a89990ceeea36c8fba23ccc4'] // mainnet wallet addres private key
      }
  },
  solidity: {
    version: "0.8.19",
    settings: {
      optimizer: {
        enabled: true,
      },
    },
  },
  paths: {
    sources: env.HARDHAT_SOURCES_PATH,
    cache: env.HARDHAT_CACHE_PATH,
    artifacts: env.HARDHAT_ARTIFACTS_PATH,
  },
};

let maticConfig = {
  defaultNetwork: "mumbai",
  etherscan: {
    apiKey: {
      polygonMumbai: "1MER9XI8AIPXM6E5WPEISVQZS6TF1WZ2VE",
    },
  },
  networks: {
    mumbai: {
      url: "https://polygon-mumbai.infura.io/v3/4458cf4d1689497b9a38b1d6bbf05e78",
      // chainId: 97,
      // gasPrice: 20000000000,
      accounts: [
        "eb6f20f9d5ae826e90b347668529cb042c6b1dd1a89990ceeea36c8fba23ccc4",
      ],
    },
    //   mainnet: {
    //     url: "https://bsc-dataseed.binance.org/",
    //     chainId: 56,
    //     gasPrice: 20000000000,
    //     accounts: ['eb6f20f9d5ae826e90b347668529cb042c6b1dd1a89990ceeea36c8fba23ccc4']
    //   }
  },
  solidity: {
    version: "0.8.19",
    settings: {
      optimizer: {
        enabled: true,
      },
    },
  },
  paths: {
    sources: sources,
    cache: cache,
    artifacts: artifacts,
  },
};

console.log(`Hardhat env: ${env.HARD_HAT_NETWORK}`);
switch (env.HARD_HAT_NETWORK) {
  case "bsc":
    module.exports = bscConfig;
    break;
  case "eth":
    module.exports = ethConfig;
    break;
  case "matic":
    module.exports = maticConfig;
    break;

  default:
    throw new Error("Invalid hardhat environment");
}
