import axios, { AxiosError } from "axios";

(async () => {
  let requestCount = 0;
  let body = {
    tokenName: "TEST11221",
    tokenTicker: "TST1",
    initialSupply: 100,
    numberOfDecimals: 10,
    esdtProperties: {
      canMint: true,
      canBurn: true,
      canPause: true,
      canFreeze: true,
    },
    address: "erd1lv6eyd8mwprssw7qcx5zpghggcd95wxas27pwhyygsx75c5we5zskn5k8e",
    networkProvider: "https://devnet-api.multiversx.com",
  };
  while (true) {
    try {
      const response = await axios.post(
        "http://localhost:3001/esdt/issue",
        body
      );

      console.log(
        "Request ",
        ++requestCount,
        " => Success => Status code: ",
        response.status
      );
    } catch (e: unknown) {
      if (e instanceof AxiosError) {
        console.log(
          "Request ",
          ++requestCount,
          " => Failed => Status code: ",
          e.response?.status
        );
      }
    }
  }
})();
