import { Request, Response } from "express";
import {
  buildControlChanges,
  buildFreeze,
  buildIssue,
  buildLocalBurn,
  buildLocalMint,
  buildPause,
  buildSetRole,
  buildTransfer,
  buildTransferOwnership,
  buildUnFreeze,
  buildUnPause,
  buildUnSetRole,
  buildWipe,
} from "../transactionBuilder";

export const issueESDT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildIssue(req.body, address, networkProvider);

  res.send(tx);
};

export const transferESDT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildTransfer(req.body, address, networkProvider);

  res.send(tx);
};

export const setSpecialRoleESDT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildSetRole(req.body, address, networkProvider);

  res.send(tx);
};

export const unSetSpecialRoleESDT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildUnSetRole(req.body, address, networkProvider);

  res.send(tx);
};

export const localMint = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildLocalMint(req.body, address, networkProvider);

  res.send(tx);
};

export const localBurn = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildLocalBurn(req.body, address, networkProvider);

  res.send(tx);
};

export const pause = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildPause(req.body, address, networkProvider);

  res.send(tx);
};

export const unPause = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildUnPause(req.body, address, networkProvider);

  res.send(tx);
};

export const freeze = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildFreeze(req.body, address, networkProvider);

  res.send(tx);
};

export const unFreeze = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildUnFreeze(req.body, address, networkProvider);

  res.send(tx);
};

export const wipe = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildWipe(req.body, address, networkProvider);

  res.send(tx);
};

export const controlChanges = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildControlChanges(req.body, address, networkProvider);

  res.send(tx);
};

export const transferOwnership = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildTransferOwnership(req.body, address, networkProvider);

  res.send(tx);
};
