import { Request, Response } from "express";
import {
  buildCreateNft,
  buildFreezeSingleNFT,
  buildIssueNft,
  buildNftAddURI,
  buildSetSpecialRoleNft,
  buildStopNftCreate,
  buildTransferNft,
  buildTransferNftCreateRole,
  buildUnFreezeSingleNFT,
  buildUpdateAttributes,
  buildwipeSingleNFT,
} from "../transactionBuilderNFT";

export const createNFT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildCreateNft(req.body, address, networkProvider);

  res.send(tx);
};

export const transferNFT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;
  console.log("transferNft accessed following buildtransfer");
  const tx = await buildTransferNft(req.body, address, networkProvider);

  res.send(tx);
};

export const issueNFT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildIssueNft(req.body, address, networkProvider);

  res.send(tx);
};

export const setSpecialRoleNFT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildSetSpecialRoleNft(req.body, address, networkProvider);

  res.send(tx);
};

export const transferCreateRoleNFT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildTransferNftCreateRole(
    req.body,
    address,
    networkProvider
  );

  res.send(tx);
};

export const stopNftCreate = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildStopNftCreate(req.body, address, networkProvider);

  res.send(tx);
};

export const updateAttributes = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildUpdateAttributes(req.body, address, networkProvider);

  res.send(tx);
};

export const addUri = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildNftAddURI(req.body, address, networkProvider);

  res.send(tx);
};

export const freezeSingleNFT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildFreezeSingleNFT(req.body, address, networkProvider);

  res.send(tx);
};

export const unFreezeSingleNFT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildUnFreezeSingleNFT(req.body, address, networkProvider);

  res.send(tx);
};

export const wipeSingleNFT = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildwipeSingleNFT(req.body, address, networkProvider);

  res.send(tx);
};
