import { Request, Response } from "express";
import {
  buildEsdtNftAddQuantity,
  buildEsdtNftBurn,
  buildEsdtNftCreate,
  buildIssueSft,
  buildSetSpecialRole,
} from "../transactionBuilderSFT";

export const issueSft = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildIssueSft(req.body, address, networkProvider);

  res.send(tx);
};

export const setSpecialRole = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildSetSpecialRole(req.body, address, networkProvider);

  res.send(tx);
};

export const esdtNftAddQuantity = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildEsdtNftAddQuantity(req.body, address, networkProvider);

  res.send(tx);
};

export const esdtNftBurn = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildEsdtNftBurn(req.body, address, networkProvider);

  res.send(tx);
};

export const esdtNftCreate = async (req: Request, res: Response) => {
  const address = req.body.address;
  const networkProvider = req.body.networkProvider;

  const tx = await buildEsdtNftCreate(req.body, address, networkProvider);

  res.send(tx);
};
