import { Elrond } from "@zoidpay-tech/zoidpay-blockchain-helpers";

export const buildRegisterMetaESDT = async (
  body: Elrond.models.MetaESDTIssue,
  address: string,
  networkProvider: Elrond.models.NetworkProvider
) => {
  const elrondInstance = new Elrond.Client({
    address: address,
    networkProvider: networkProvider,
  });

  const tx = await elrondInstance.buildTransaction({
    transactionCategory: Elrond.models.TransactionCategory.METAESDT,
    transactionType: Elrond.models.MetaESDTFunctions.registerMetaESDT,
    operationsData: body,
  });

  return tx;
};

export const buildChangeSftToMetaEsdt = async (
  body: Elrond.models.ConvertSftMetaESDT,
  address: string,
  networkProvider: Elrond.models.NetworkProvider
) => {
  const elrondInstance = new Elrond.Client({
    address: address,
    networkProvider: networkProvider,
  });

  const tx = await elrondInstance.buildTransaction({
    transactionCategory: Elrond.models.TransactionCategory.METAESDT,
    transactionType: Elrond.models.MetaESDTFunctions.changeSFTToMetaESDT,
    operationsData: body,
  });

  return tx;
};
