import { Elrond } from "@zoidpay-tech/zoidpay-blockchain-helpers";

export const buildIssueSft = async (
  body: Elrond.models.SFTIssueData,
  address: string,
  networkProvider: Elrond.models.NetworkProvider
) => {
  const elrondInstance = new Elrond.Client({
    address: address,
    networkProvider: networkProvider,
  });

  const tx = await elrondInstance.buildTransaction({
    transactionCategory: Elrond.models.TransactionCategory.SFT,
    transactionType: Elrond.models.SFTFunctions.issueSemiFungible,
    operationsData: body,
  });

  return tx;
};

export const buildSetSpecialRole = async (
  body: Elrond.models.SFTSetSpecialRoleData,
  address: string,
  networkProvider: Elrond.models.NetworkProvider
) => {
  const elrondInstance = new Elrond.Client({
    address: address,
    networkProvider: networkProvider,
  });

  const tx = await elrondInstance.buildTransaction({
    transactionCategory: Elrond.models.TransactionCategory.SFT,
    transactionType: Elrond.models.SFTFunctions.setSpecialRole,
    operationsData: body,
  });

  return tx;
};

export const buildEsdtNftAddQuantity = async (
  body: Elrond.models.ESDTNFTAddQuantity,
  address: string,
  networkProvider: Elrond.models.NetworkProvider
) => {
  const elrondInstance = new Elrond.Client({
    address: address,
    networkProvider: networkProvider,
  });

  const tx = await elrondInstance.buildTransaction({
    transactionCategory: Elrond.models.TransactionCategory.SFT,
    transactionType: Elrond.models.SFTFunctions.ESDTNFTAddQuantity,
    operationsData: body,
  });

  return tx;
};

export const buildEsdtNftBurn = async (
  body: Elrond.models.ESDTNFTBurn,
  address: string,
  networkProvider: Elrond.models.NetworkProvider
) => {
  const elrondInstance = new Elrond.Client({
    address: address,
    networkProvider: networkProvider,
  });

  const tx = await elrondInstance.buildTransaction({
    transactionCategory: Elrond.models.TransactionCategory.SFT,
    transactionType: Elrond.models.SFTFunctions.ESDTNFTBurn,
    operationsData: body,
  });

  return tx;
};

export const buildEsdtNftCreate = async (
  body: Elrond.models.ESDTNFTCreate,
  address: string,
  networkProvider: Elrond.models.NetworkProvider
) => {
  const elrondInstance = new Elrond.Client({
    address: address,
    networkProvider: networkProvider,
  });

  const tx = await elrondInstance.buildTransaction({
    transactionCategory: Elrond.models.TransactionCategory.SFT,
    transactionType: Elrond.models.SFTFunctions.ESDTNFTCreate,
    operationsData: body,
  });

  return tx;
};
