/*
 Checks if payload is valid and throws error if it is not.
 */
import { NextFunction } from "express";
import { Request, Response } from "express";
import { Elrond } from "@zoidpay-tech/zoidpay-blockchain-helpers";

export const nftCreateValidator = (
  req: Request,
  res: Response,
  next: NextFunction
) => {
  const payload = req.body;

  if (!payload.address)
    throw new Error("The `address` parameter is not present.");
  if (!payload.tokenIdentifier)
    throw new Error("The `tokenIdentifier` parameter is not present.");
  if (!payload.nftName)
    throw new Error("The `nftName` parameter is not present.");
  if (!payload.royalties)
    throw new Error("The `royalties` parameter is not present.");
  if (!payload.addressToSendTo)
    throw new Error("The `addressToSendTo` parameter is not present.");
  if (!payload.URILinks)
    throw new Error("The `URILinks` parameter is not present.");
  if (!payload.senderAddress)
    throw new Error("The `senderAddress` parameter is not present.");
  if (!payload.hash) throw new Error("The `URILinks` hash is not present.");
  if (!payload.hash) throw new Error("The `attributes` hash is not present.");
  if (!payload.nftName)
    throw new Error("The `nftName` parameter is not present.");
  if (!payload.networkProvider)
    throw new Error(
      `The 'networkProvider' parameter is not present. Please provide one of the following network providers: '${Elrond.models.NetworkProvider.devnet}', '${Elrond.models.NetworkProvider.mainnet}', '${Elrond.models.NetworkProvider.testnet}'`
    );

  next();
};
